<?php 
defined('BASEPATH') OR exit('No direct script access allowed');

class Invoice extends CI_Controller {

	public function __construct()
     {
          parent::__construct();
          $this->load->helper('url');
          $this->load->helper('form');
          $this->load->database();
          $this->load->model('invoice_model');
          $this->load->model('customer_model');
          $this->load->model('employee_model');
          $this->load->model('service_model');
          $this->load->model('SalesTaxReceipt_model');

     }

	public function index()
    {
        $custresult = $this->customer_model->get_customers_list();           
        $data['custlist'] = $custresult;
        $empresult = $this->employee_model->get_employee_list();           
        $data['emplist'] = $empresult;
        $serresult = $this->service_model->get_service_list();           
        $data['serlist'] = $serresult;
        //load the invoice_view
        if($this->session->userdata('isUserLoggedIn')){
           $this->load->view('header');
           $this->load->view('invoice_view',$data);
           $this->load->view('footer');      
        }else{
            redirect('login');
        }
    }

    public function insert_invoice(){
      $service_tax = $this->input->post('service_tax') / 100;
      $customerid = $this->input->post('customer');
      $salestax = $this->input->post('salestax');
      $d = date_parse_from_format("Y-m-d", $this->input->post('invoice_date'));
      $new_invoice = array(
        'InvoiceDate' => $this->input->post('invoice_date'),
        'DueDate' =>$this->input->post('payment_due'),
        'ServicesTaxRate'=>$service_tax,
        'ServicesTotal' => $this->input->post('service_total'),
        'InvoiceNumber'=> $this->invoice_model->getInvoiceNumber(),
        'Submitted'=>$this->input->post('date_submitted'),
        'Job'=>$this->input->post('job'),
        'StatusText'=>'Submitted',
        'PaymentTerms'=>$this->input->post('payment_terms'),
        'ContactName' => $this->input->post('contact_name'),
        'ContactPhone' => $this->input->post('contact_number'),
        'CompanyName'=> $this->input->post('company_name'),
        'ServiceAddress'=> $this->input->post('address'),
        'ServiceCity'=> $this->input->post('city'),
        'ServiceState'=> $this->input->post('state'),
        'ServiceCountry'=> $this->input->post('country'),
        'Tax'=> $this->input->post('tax_total'),
        'CustomerID'=> $this->input->post('customer'),
        'SalespersonID'=> $this->input->post('salesperson'),
        'IsPaid'=> 'False',
        'IsSubmitted'=> 'True',
        'Notes'=> $this->input->post('notes'),
        'StatusID'=>'10',
        'InvoiceQuarter'=> $this->invoice_model->getQuarter($d['month']),
        'InvoiceMonth'=> $d['month'],
        'InvoiceYear'=> $d['year'],
        'InvoiceTotal'=> $this->input->post('invoice_total'),
        'ProjectStartDate'=> $this->input->post('project_start_date'),
        'ProjectEndDate'=> $this->input->post('project_end_date'),
        'SalesTax'=>$this->input->post('salestax'),
        'ShowTax'=>$this->input->post('showTax')
      );

        $new_id=$this->invoice_model->insert_new_invoice($new_invoice);
        $service_count = $this->input->post('service_count');
       

        for($i=1; $i<=$service_count; $i++ ){
          if ($this->input->post('service_desc'.$i) != NULL){
            $service_id=$this->input->post('service'.$i);
            $service_desc=$this->input->post('service_desc'.$i);
            $service_rate=$this->input->post('service_rate'.$i);
            $invoice_service= array(
            'InvoiceID' =>$new_id,
            'ServiceID'=>$service_id,
            'ServiceDescription' => $service_desc,
            'ServiceTotal' => $service_rate
            );

             $i_s=$this->invoice_model->insert_invoice_service($invoice_service);
          }
          

        }

        $invoice_counter = $this->customer_model->increment_invoiceCounter($customerid);

        if($salestax == 'Yes'){
          $this->SalesTaxReceipt_model->add_salestax($new_id);
        }

        redirect("salesInvoice");
    
    }
}